import matplotlib.pyplot as plt
import math
Delta_t = 10 #la position des planètes est enregistrée tous les 10 jours
Suivi = 1#le suivi sera effectué pendant cette durée exprimée en année
i = 0
#toutes les distances sont exprimées en mètre

######################################################################################
###############          A COMPLETER                     #############################
######################################################################################

#pour la Terre

a_3 = 1.49598e11 # demi grand axe
e_3 = 0.0167     #excentricité sans unité
T_3 = 365.256    #période de révolution en jours terrestres

#pour Mars

a_4 = 2.27937e11 # demi grand axe
e_4 = 0.09341    #excentricité sans unité
T_4 = 686.96     #période de révolution en jours terrestres

#####################################################################################
#####################################################################################

#les variables de position sont définies comme des listes
#dans le référentiel héliocentrique
X_T_helio = []
Y_T_helio = []
X_M_helio = []
Y_M_helio = []
#dans le référentiel géocentrique
X_M_geo = []
Y_M_geo = []

n_3 = math.floor(T_3/Delta_t)
while i <= Suivi*n_3:
    #positions successives de la Terre et de Mars dans le référentiel héliocentrique
    x_t_i = -a_3*e_3+a_3*math.cos(2*math.pi*Delta_t*i/T_3)
    y_t_i = a_3*math.sqrt(1-e_3*e_3)*math.sin(2*math.pi*Delta_t*i/T_3)
    x_m_i = -a_4*e_4+a_4*math.cos(2*math.pi*Delta_t*i/T_4+math.pi/4)
    y_m_i = a_4*math.sqrt(1-e_4*e_4)*math.sin(2*math.pi*Delta_t*i/T_4+math.pi/4)
    #définir les coordonnées de Mars dans le référentiel géocentrique
    xm=x_m_i - x_t_i
    ym=y_m_i - y_t_i
    #ajouter les positions calculées aux listes qui les contiennent toutes
    X_T_helio.append(x_t_i)
    Y_T_helio.append(y_t_i)
    X_M_helio.append(x_m_i)
    Y_M_helio.append(y_m_i)
    X_M_geo.append(xm)
    Y_M_geo.append(ym)
    i += 1

#si on veut tracer les positions de Mars et de la Terre dans le référentiel héliocentrique :
for j in range(Suivi*n_3):
    plt.title("Mouvement de la Terre et de Mars dans le référentiel héliocentrique")
    plt.xlim(-3e11, 3e11)
    plt.ylim(-3e11, 3e11)
    plt.plot(X_T_helio[j], Y_T_helio[j], ".")
    plt.plot(X_M_helio[j], Y_M_helio[j], ".")
    plt.plot(0,0, "+")
    plt.pause(0.05)
    plt.grid(True)
    plt.axis('equal')
plt.annotate('    Soleil', xy=(0,0))
plt.annotate('    Terre, 1er jour', xy=(X_T_helio[0], Y_T_helio[0]))
plt.annotate('    Mars, 1er jour', xy=(X_M_helio[0], Y_M_helio[0]))
plt.savefig('trajectoires_terre_mars_helio.png')
plt.show()
plt.close()

#si on veut tracer les positions de Mars dans le référentiel géocentrique
###############################################################################
#############              À REDIGER               ############################
###############################################################################
plt.annotate('Terre', xy=(0,0))
for j in range(Suivi*n_3):
    plt.title("Mouvement de Mars dans le référentiel géocentrique")
    plt.xlim(-5e11, 5e11)
    plt.ylim(-5e11, 5e11)
    plt.plot(X_M_geo[j], Y_M_geo[j], ".")
    plt.plot(0, 0, "+", label='Terre')
    plt.pause(0.05)
    plt.grid(True)
    plt.axis('equal')
plt.annotate('    Mars', xy=(X_M_geo[0], Y_M_geo[0]))
plt.savefig('mouvement_retrograde_mars.png')
plt.show()
plt.close()
